 //--------------------------------------------------------------------------------------------------
 // Copyright (c) 2011,2012 FZ Software
 // All rights reserved.
 //
 // Redistribution and use in source and binary forms, with or without modification, are permitted
 // provided that the following conditions are met:
 //
 // Redistributions of source code must retain the above copyright notice, this list of
 // conditions and the following disclaimer.
 //
 // Redistributions in binary form must reproduce the above copyright notice, this list of
 // conditions and the following disclaimer in the documentation and/or other materials provided with
 // the distribution.
 // Neither the name of this project nor the names of its contributors may be used to endorse
 // or promote products derived from this software without specific prior written permission.
 //
 // THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR
 // IMPLIED WARRANTIES, INCLUDING BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTIBILITY AND
 // FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE COPYRIGHT OWNER OR
 // CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 // DAMAGES (INCLUDING BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 // DATA OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER
 // IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
 // OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 //
 // this is simplified version of code to run the battery charger circuit using 12F683
 // for public release
 //--------------------------------------------------------------------------------------------------
#ifdef PIC12F629
#pragma  cdata[0x3ff] = __RETLW(0x88)
#endif

#ifdef PIC12F683
#pragma  cdata[ADDRESS_LAST_CODE_LOCATION] = __RETLW(0x8c)
#endif
//////////////////////////////////////////////////////////////////////////
// EEPROM //////////////////
//////////////////////////////////////////////////////////////////////////
#pragma  cdata[_EEADR+_EEADDR_StartChar] = '$'
#pragma  cdata[_EEADR+_EEADDR_DeviceAddress] = 0xee
#pragma  cdata[_EEADR+_EEADDR_DeviceAddress+1] = 0x1f
#pragma  cdata[_EEADR+_EEADDR_DeviceType] = 07
#pragma  cdata[_EEADR+_EEADDR_DeviceVersion] = 2

#pragma  cdata[_EEADR+_EEADDR_VOLTSREF]           = VOLTSDB(fract(5,0))
#pragma  cdata[_EEADR+_EEADDR_VOLTRANGE]          = VOLTSDB((V_Normed(VinMAX)))
#pragma  cdata[_EEADR+_EEADDR_VOLTSINMAX]         = VOLTSDB((VinNormed(13.70)))
#pragma  cdata[_EEADR+_EEADDR_VOLTSINMAX_VREF]         = VOLTSDB((VinREFNormed(13.70)))


//----------------------
//NiMh parameters

#pragma	cdata[_EEADR+_EEADDR_CELL_NIMH_PARMS+ ECELL_TYPE] = 2
#pragma	cdata[_EEADR+_EEADDR_CELL_NIMH_PARMS+ ECELL_VOLTAGE] =VOLTSDB((VinREFNormed(1.35)))
#pragma	cdata[_EEADR+_EEADDR_CELL_NIMH_PARMS+ ECELL_OPERATING_VOLTAGE_LOW] =VOLTSDB((VinREFNormed(0.90)))
#pragma	cdata[_EEADR+_EEADDR_CELL_NIMH_PARMS+ ECELL_OPERATING_VOLTAGE_HIGH] =VOLTSDB((VinREFNormed(1.278)))

#pragma	cdata[_EEADR+_EEADDR_CELL_NIMH_PARMS+ ECELL_VOLTAGE_CRITICAL_LOW] =VOLTSDB((VinREFNormed(0.5)))
#pragma	cdata[_EEADR+_EEADDR_CELL_NIMH_PARMS+ ECELL_CRITICAL_LOW_CHRG_PULSE_VOLTAGE] =VOLTSDB((VinREFNormed(3.00)))
#pragma	cdata[_EEADR+_EEADDR_CELL_NIMH_PARMS+ ECELL_CRITICAL_LOW_CHRG_MAXTIME] =EEINT(05)
#pragma	cdata[_EEADR+_EEADDR_CELL_NIMH_PARMS+ ECELL_CRITICAL_LOW_PULSERATE] =PERMINUTE_TICKS(10)

#pragma	cdata[_EEADR+_EEADDR_CELL_NIMH_PARMS+ ECELL_VOLTAGE_FOR_LOW_CHARGE_PULSE] =VOLTSDB((VinREFNormed(0.80)))
#pragma	cdata[_EEADR+_EEADDR_CELL_NIMH_PARMS+ ECELL_LOW_CHARGE_PULSE_MAXTIME] =EEINT(30)
#pragma	cdata[_EEADR+_EEADDR_CELL_NIMH_PARMS+ ECELL_LOW_CHARGE_PULSERATE ] =PERMINUTE_TICKS(30)

#pragma	cdata[_EEADR+_EEADDR_CELL_NIMH_PARMS+ ECELL_VOLTAGE_CHARGE_BULK] =VOLTSDB((VinREFNormed(0.96)))
#pragma	cdata[_EEADR+_EEADDR_CELL_NIMH_PARMS+ ECELL_CHARGE_BULK_MAXTIME] =EEINT(300)
#pragma	cdata[_EEADR+_EEADDR_CELL_NIMH_PARMS+ ECELL_CHARGE_BULK_VOLTAGE ] =VOLTSDB((VinREFNormed(2.45)))

#pragma	cdata[_EEADR+_EEADDR_CELL_NIMH_PARMS+ ECELL_EOC_VOLTAGE] =VOLTSDB((VinREFNormed(1.62)))
#pragma	cdata[_EEADR+_EEADDR_CELL_NIMH_PARMS+ ECELL_EOC_PULSE_VOLTAGE] =VOLTSDB((VinREFNormed(2.30)))
#pragma	cdata[_EEADR+_EEADDR_CELL_NIMH_PARMS+ ECELL_EOC_PULSERATE ] =PERMINUTE_TICKS(15)
#pragma	cdata[_EEADR+_EEADDR_CELL_NIMH_PARMS+ ECELL_EOC_PULSE_MAXTIME] =EEINT(60)

#pragma	cdata[_EEADR+_EEADDR_CELL_NIMH_PARMS+ ECELL_OVER_CHARGE] =VOLTSDB((VinREFNormed(1.78)))
#pragma	cdata[_EEADR+_EEADDR_CELL_NIMH_PARMS+ ECELL_EOC_DT] =EEINT(16)
#pragma	cdata[_EEADR+_EEADDR_CELL_NIMH_PARMS+ ECELL_EOC_DV] =VOLTSDB((VinREFNormed(0.035)))
#pragma	cdata[_EEADR+_EEADDR_CELL_NIMH_PARMS+ ECELL_EOC_DV_TIME] =EEINT(2)

#pragma	cdata[_EEADR+_EEADDR_CELL_NIMH_PARMS+ ECELL_FLOAT_PULSERATE ] =PERMINUTE_TICKS(2)
#pragma	cdata[_EEADR+_EEADDR_CELL_NIMH_PARMS+ ECELL_FLOAT_PULSE_VOLTAGE] =VOLTSDB((VinREFNormed(2.30)))


#pragma	cdata[_EEADR+_EEADDR_CELL_NIMH_PARMS+ ECELL_MAX_TEMPERATURE] =EEINT(720) // temperature reading
#pragma	cdata[_EEADR+_EEADDR_CELL_NIMH_PARMS+ ECELL_CHARGE_CUTOFF_TIME] =EEINT(360) // no of ticks
#pragma	cdata[_EEADR+_EEADDR_CELL_NIMH_PARMS+ ECELL_TEMPERATURE_START_BULKCHARGE_TRESHOLD] =EEINT(637) // no of ticks

// parameters for 2 batteries
#pragma	cdata[_EEADR+_EEADDR_CELL_NIMH_PARMS_2+ ECELL_TYPE] = 3
#pragma	cdata[_EEADR+_EEADDR_CELL_NIMH_PARMS_2+ ECELL_VOLTAGE] =VOLTSDB((VinREFNormed(1.35*2.0)))
#pragma	cdata[_EEADR+_EEADDR_CELL_NIMH_PARMS_2+ ECELL_OPERATING_VOLTAGE_LOW] =VOLTSDB((VinREFNormed(0.90*2.0)))
#pragma	cdata[_EEADR+_EEADDR_CELL_NIMH_PARMS_2+ ECELL_OPERATING_VOLTAGE_HIGH] =VOLTSDB((VinREFNormed(1.278*2.0)))

#pragma	cdata[_EEADR+_EEADDR_CELL_NIMH_PARMS_2+ ECELL_VOLTAGE_CRITICAL_LOW] =VOLTSDB((VinREFNormed(0.5*2.0)))
#pragma	cdata[_EEADR+_EEADDR_CELL_NIMH_PARMS_2+ ECELL_CRITICAL_LOW_CHRG_PULSE_VOLTAGE] =VOLTSDB((VinREFNormed(3.00*2.0)))
#pragma	cdata[_EEADR+_EEADDR_CELL_NIMH_PARMS_2+ ECELL_CRITICAL_LOW_CHRG_MAXTIME] =EEINT(02)
#pragma	cdata[_EEADR+_EEADDR_CELL_NIMH_PARMS_2+ ECELL_CRITICAL_LOW_PULSERATE] =PERMINUTE_TICKS(12)

#pragma	cdata[_EEADR+_EEADDR_CELL_NIMH_PARMS_2+ ECELL_VOLTAGE_FOR_LOW_CHARGE_PULSE] =VOLTSDB((VinREFNormed(0.80*2.0)))
#pragma	cdata[_EEADR+_EEADDR_CELL_NIMH_PARMS_2+ ECELL_LOW_CHARGE_PULSE_MAXTIME] =EEINT(30)
#pragma	cdata[_EEADR+_EEADDR_CELL_NIMH_PARMS_2+ ECELL_LOW_CHARGE_PULSERATE ] =PERMINUTE_TICKS(30)

#pragma	cdata[_EEADR+_EEADDR_CELL_NIMH_PARMS_2+ ECELL_VOLTAGE_CHARGE_BULK] =VOLTSDB((VinREFNormed(0.90*2.0)))
#pragma	cdata[_EEADR+_EEADDR_CELL_NIMH_PARMS_2+ ECELL_CHARGE_BULK_MAXTIME] =EEINT(300)
#pragma	cdata[_EEADR+_EEADDR_CELL_NIMH_PARMS_2+ ECELL_CHARGE_BULK_VOLTAGE ] =VOLTSDB((VinREFNormed(2.45*2.0)))

#pragma	cdata[_EEADR+_EEADDR_CELL_NIMH_PARMS_2+ ECELL_EOC_VOLTAGE] =VOLTSDB((VinREFNormed(1.62*2.0)))
#pragma	cdata[_EEADR+_EEADDR_CELL_NIMH_PARMS_2+ ECELL_EOC_PULSE_VOLTAGE] =VOLTSDB((VinREFNormed(2.30*2.0)))
#pragma	cdata[_EEADR+_EEADDR_CELL_NIMH_PARMS_2+ ECELL_EOC_PULSERATE ] =PERMINUTE_TICKS(15)
#pragma	cdata[_EEADR+_EEADDR_CELL_NIMH_PARMS_2+ ECELL_EOC_PULSE_MAXTIME] =EEINT(60)

#pragma	cdata[_EEADR+_EEADDR_CELL_NIMH_PARMS_2+ ECELL_OVER_CHARGE] =VOLTSDB((VinREFNormed(1.78*2.0)))
#pragma	cdata[_EEADR+_EEADDR_CELL_NIMH_PARMS_2+ ECELL_EOC_DT] =EEINT(16)
#pragma	cdata[_EEADR+_EEADDR_CELL_NIMH_PARMS_2+ ECELL_EOC_DV] =VOLTSDB((VinREFNormed(0.05)))
#pragma	cdata[_EEADR+_EEADDR_CELL_NIMH_PARMS_2+ ECELL_EOC_DV_TIME] =EEINT(2)

#pragma	cdata[_EEADR+_EEADDR_CELL_NIMH_PARMS_2+ ECELL_FLOAT_PULSERATE ] =PERMINUTE_TICKS(4)
#pragma	cdata[_EEADR+_EEADDR_CELL_NIMH_PARMS_2+ ECELL_FLOAT_PULSE_VOLTAGE] =VOLTSDB((VinREFNormed(2.30*2.0)))


#pragma	cdata[_EEADR+_EEADDR_CELL_NIMH_PARMS_2+ ECELL_MAX_TEMPERATURE] =EEINT(720) // no of ticks
#pragma	cdata[_EEADR+_EEADDR_CELL_NIMH_PARMS_2+ ECELL_CHARGE_CUTOFF_TIME] =EEINT(360) // no of ticks


//-----------------------
/*
#pragma cdata[_EEADR+_EEADDR_CREF_TABLE]   = VOLTSLOBYT((VinREFNormed(0.208))),(1<<nVRR)|1
#pragma cdata[_EEADR+_EEADDR_CREF_TABLE+1] = VOLTSLOBYT((VinREFNormed(0.416))),(1<<nVRR)|2
#pragma cdata[_EEADR+_EEADDR_CREF_TABLE+2] = VOLTSLOBYT((VinREFNormed(0.625))),(1<<nVRR)|3
#pragma cdata[_EEADR+_EEADDR_CREF_TABLE+3] = VOLTSLOBYT((VinREFNormed(0.833))),(1<<nVRR)|4
#pragma cdata[_EEADR+_EEADDR_CREF_TABLE+4] = VOLTSLOBYT((VinREFNormed(1.042))),(1<<nVRR)|5
#pragma cdata[_EEADR+_EEADDR_CREF_TABLE+5] = VOLTSLOBYT((VinREFNormed(1.25))),(1<<nVRR)|6
#pragma cdata[_EEADR+_EEADDR_CREF_TABLE+5] = VOLTSLOBYT((VinREFNormed(1.406))),(0<<nVRR)|0
#pragma cdata[_EEADR+_EEADDR_CREF_TABLE+5] = VOLTSLOBYT((VinREFNormed(1.458))),(1<<nVRR)|7
#pragma cdata[_EEADR+_EEADDR_CREF_TABLE+5] = VOLTSLOBYT((VinREFNormed(1.563))),(0<<nVRR)|7
*/




#pragma packedCdataStrings 1
#pragma cdata[_EEADR+150] = 's','w','-','r','e','g',' ','F','Z',' ','S','o','f','t','w','a','r','e',10,0,0
#pragma cdata[] = __DATE2__
