// picstd.h
#ifndef _PICSTD_H
#define _PICSTD_H
/////////////////////////////////////////////////////////////////////

#define TMR0_COUNTOVER 256
#define TMR1_COUNTOVER 65536
#define TMR2_COUNTOVER 65536

#if defined(T0PSD)
 #if T0PSD==2
   #define OPT_PSD 0
 #elif T0PSD==4
   #define OPT_PSD 1
 #elif T0PSD==8
   #define OPT_PSD 2
 #elif T0PSD==16
   #define OPT_PSD 3
 #elif TOPSD==32
   #define OPT_PSD 4
 #elif T0PSD==64
   #define OPT_PSD 5
 #elif T0PSD==128
   #define OPT_PSD 6
 #elif T0PSD==256
   #define OPT_PSD 7
 #else
   #error Invalid T0 prescaler value
 #endif
#endif


#if defined(WDPSD)
  #if WDPSD==1
    #define OPT_PSD 0
  #elif WDPSD==2
    #define OPT_PSD 1
  #elif WDPSD==4
    #define OPT_PSD 2
  #elif WDPSD==8
    #define OPT_PSD 3
  #elif WDPSD==16
    #define OPT_PSD 4
  #elif WDPSD==32
    #define OPT_PSD 5
  #elif WDPSD==64
    #define OPT_PSD 6
  #elif WDPSD==128
    #define OPT_PSD 7
  #else
    #error Invalid Prescaler value for watchdog
  #endif
#endif



	#if Ticker_TIMER == USE_TMR0
		#warning "Ticker:timer 0 used"
		#define D_COUNTOVER TMR0_COUNTOVER
	#elif Ticker_TIMER == USE_TMR1
		#pragma warning "Ticker:timer 1 used"
		#define D_COUNTOVER TMR1_COUNTOVER
	#elif Ticker_TIMER == USE_TMR2
		#pragma warning "Ticker:timer 2 used"
		#define D_COUNTOVER TMR2_COUNTOVER
    #else
        #define D_COUNTOVER 1
	#endif


   #if defined(T0PSD)
     #define D_PSD T0PSD
   #else
     #define D_PSD 1
   #endif

//   No.of milliseconds for counter rollover
//
//  num of counts for overflow with prescaler
    #define D_TICKER_OF (D_COUNTOVER*D_PSD)
// //milliseconds for counter rollover scaled by 100
    #define D_TICKCOUNTS_ROLL ((D_TICKER_OF*1000*100)/(APROCFREQ/4))

    #if ((TickerMilliTick*100) <= D_TICKCOUNTS_ROLL )
    // the resolution may not be very accurate unless exact multiple is used
      #define D_TICKCOUNTS_WORDS 0
      #define D_TICKCOUNTS  (D_TICKCOUNTS_ROLL/(TickerMilliTick*100))
	  #define D_TICKRESET_VALUE   (COUNTOVER-(TickerMilliTick*(((APROCFREQ/4)/D_PSD)/1000)))
      #define D_TICKRESET_VALUE_HI  ((D_TICKRESET_VALUE & 0xff00)>>8)
      #define D_TICKRESET_VALUE_LO  (D_TICKRESET_VALUE & 0x00ff)
	#else
	  #define D_TICKSCOUNT ((TickerMilliTick*100)/D_TICKCOUNTS_ROLL)
	  #if (D_TICKSCOUNT) > 255
	     #define  D_TICKCOUNTS_WORDS 2
		 #define TICKCOUNTS_1 ((D_TICKSCOUNT & 0xff00)>>8)
		 #define TICKCOUNTS_0  (D_TICKSCOUNT & 0x00ff)
		 #warning "Ticker is 2 words"
	  #else
		 #define  D_TICKCOUNTS_WORDS 1
		 #define TICKCOUNTS  D_TICKSCOUNT
		 #warning "Ticker is 1 word"
	  #endif
	#endif


    #define TICKSFORSECOND (1000/TickerMilliTick)

/////////////////////
//default OPTION
#define  OPTION_GPPU   0	//default: PORTB pull-ups enabled by default
#define  OPTION_INTEDG 0	//default: Interrupt on falling Edge
#define  OPTION_T0CS   0
#define  OPTION_T0SE   0
#define  OPTION_PSA    0
#define  OPTION_PS20   0		// Pull ups on PORTB by default



#ifdef OPT_PSD
 #ifdef  OPTION_PS20
   #undef  OPTION_PS20
 #endif
 #define OPTION_PS20 OPT_PSD
#endif

#ifdef UseOsc
 #ifdef OPTION_T0CS
   #undef OPTION_T0CS
 #endif
 #define OPTION_T0CS ((!UseOsc)<<T0CS)
#endif

#ifdef UseSourceEdgeH2L
 #ifdef OPTION_T0SE
   #undef OPTION_T0SE
 #endif
 #define OPTION_T0SE ((1)<<T0SE)
#endif


#endif
